Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPCharacteristicCalculator.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPCharacteristicCalculator.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPCharacteristicCalculator.cs	(revision 16137)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.QuadraticAssignment;
+
+namespace HeuristicLab.Analysis.FitnessLandscape {
+  [Item("QAP Characteristic Calculator", "")]
+  [StorableClass]
+  public sealed class QAPCharacteristicCalculator : CharacteristicCalculator {
+
+    [StorableConstructor]
+    private QAPCharacteristicCalculator(bool deserializing) : base(deserializing) { }
+    private QAPCharacteristicCalculator(QAPCharacteristicCalculator original, Cloner cloner) : base(original, cloner) { }
+    public QAPCharacteristicCalculator() {
+      characteristics.AddRange(new[] { "Dimension",
+        "FlowDominance", "DistanceDominance",
+        "FlowAsymmetry", "DistanceAsymmetry",
+        "FlowSparsity", "DistanceSparsity",
+        "FlowSkewness", "DistanceSkewness",
+        "FlowDisparity", "DistanceDisparity" }.Select(x => new StringValue(x)).ToList());
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new QAPCharacteristicCalculator(this, cloner);
+    }
+
+    public override bool CanCalculate() {
+      return Problem is QuadraticAssignmentProblem;
+    }
+
+    public override IEnumerable<IResult> Calculate() {
+      var qap = Problem as QuadraticAssignmentProblem;
+      if (qap == null) throw new ArgumentException("Instance is not of type QuadraticAssignmentProblem");
+      foreach (var chara in characteristics.CheckedItems.Select(x => x.Value.Value)) {
+        if (chara == "Dimension")
+          yield return new Result(chara, new IntValue(qap.Weights.Rows));
+        else if (chara == "FlowDominance")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.CoeffVariation(qap.Weights)));
+        else if (chara == "DistanceDominance")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.CoeffVariation(qap.Distances)));
+        else if (chara == "FlowAsymmetry")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Asymmetry(qap.Weights)));
+        else if (chara == "DistanceAsymmetry")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Asymmetry(qap.Distances)));
+        else if (chara == "FlowSparsity")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Sparsity(qap.Weights)));
+        else if (chara == "DistanceSparsity")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Sparsity(qap.Distances)));
+        else if (chara == "FlowSkewness")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Skewness(qap.Weights)));
+        else if (chara == "DistanceSkewness")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Skewness(qap.Distances)));
+        else if (chara == "FlowDisparity")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Disparity(qap.Weights)));
+        else if (chara == "DistanceDisparity")
+          yield return new Result(chara, new DoubleValue(DoubleMatrixCharacteristics.Disparity(qap.Distances)));
+      }
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPDirectedWalk.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPDirectedWalk.cs	(revision 16137)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/QAP/QAPDirectedWalk.cs	(revision 16137)
@@ -0,0 +1,305 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.QuadraticAssignment;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Analysis.FitnessLandscape {
+  [Item("Directed Walk (QAP-specific)", "")]
+  [StorableClass]
+  public class QAPDirectedWalk : CharacteristicCalculator {
+
+    public enum WalkType { RandomRandom, RandomGlobal, RandomLocal, LocalLocal, LocalGlobal, LocalInverse }
+
+    private const string NBHOOD_STR = "Swap2";
+    
+    public IFixedValueParameter<IntValue> PathsParameter {
+      get { return (IFixedValueParameter<IntValue>)Parameters["Paths"]; }
+    }
+
+    public IFixedValueParameter<BoolValue> BestImprovementParameter {
+      get { return (IFixedValueParameter<BoolValue>)Parameters["BestImprovement"]; }
+    }
+
+    public IValueParameter<IntValue> SeedParameter {
+      get { return (IValueParameter<IntValue>)Parameters["Seed"]; }
+    }
+
+    public IFixedValueParameter<EnumValue<WalkType>> TypeParameter {
+      get { return (IFixedValueParameter<EnumValue<WalkType>>)Parameters["Type"]; }
+    }
+
+    public int Paths {
+      get { return PathsParameter.Value.Value; }
+      set { PathsParameter.Value.Value = value; }
+    }
+
+    public bool BestImprovement {
+      get { return BestImprovementParameter.Value.Value; }
+      set { BestImprovementParameter.Value.Value = value; }
+    }
+
+    public int? Seed {
+      get { return SeedParameter.Value != null ? SeedParameter.Value.Value : (int?)null; }
+      set { SeedParameter.Value = value.HasValue ? new IntValue(value.Value) : null; }
+    }
+
+    public WalkType Type {
+      get { return TypeParameter.Value.Value; }
+      set { TypeParameter.Value.Value = value;}
+    }
+
+    [StorableConstructor]
+    private QAPDirectedWalk(bool deserializing) : base(deserializing) { }
+    private QAPDirectedWalk(QAPDirectedWalk original, Cloner cloner) : base(original, cloner) { }
+    public QAPDirectedWalk() {
+      characteristics.AddRange(CurveAnalysisResult.AllFeatures.Select(x => new StringValue(x.ToString())));
+      characteristics.AddRange(new[] { "AutoCorrelation1", "CorrelationLength", "InformationContent",
+        "DensityBasinInformation", "PartialInformationContent", "InformationStability",
+        "Diversity", "Regularity", "TotalEntropy", "PeakInformationContent",
+        "PeakDensityBasinInformation" }.Select(x => new StringValue(x)));
+
+      Parameters.Add(new FixedValueParameter<IntValue>("Paths", "The number of paths to explore (a path is a set of solutions that connect two randomly chosen solutions).", new IntValue(50)));
+      Parameters.Add(new FixedValueParameter<BoolValue>("BestImprovement", "Whether the best of all alternatives should be chosen for each step in the path or just the first improving (least degrading) move should be made.", new BoolValue(true)));
+      Parameters.Add(new OptionalValueParameter<IntValue>("Seed", "The seed for the random number generator."));
+      Parameters.Add(new FixedValueParameter<EnumValue<WalkType>>("Type", "Type of directed walk to perfom.", new EnumValue<WalkType>(WalkType.RandomRandom)));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new QAPDirectedWalk(this, cloner);
+    }
+
+    public override bool CanCalculate() {
+      return Problem is QuadraticAssignmentProblem;
+    }
+
+    private double _evaluatedSolutions;
+
+    public override IEnumerable<IResult> Calculate() {
+      _evaluatedSolutions = 0;
+      var permutations = CalculateRelinkingPoints();
+
+      var trajectories = Run(permutations).ToList();
+      var result = CurveAnalysis<Permutation>.GetCharacteristics(trajectories, (left, right) => (1.0 - HammingSimilarityCalculator.CalculateSimilarity(left, right)) * left.Length);
+
+      #region Calculate Features
+      double avgAc1 = 0, avgCorLen = 0, avgIc = 0, avgDbi = 0, avgPic = 0, avgIS = 0, avgDiv = 0,
+        avgReg = 0, avgEnt = 0, avgPkIc = 0, avgPkDbi = 0;
+      int count = 0;
+      foreach (var t in trajectories) {
+        var trail = t.Select(x => x.Item2).ToArray();
+        if (trail.Length < 4) continue;
+        count++;
+        double[] acf;
+        var len = RuggednessCalculator.CalculateCorrelationLength(trail, out acf);
+        avgAc1 += acf[1];
+        avgCorLen += len;
+        var analysis = new InformationAnalysis(trail);
+        avgIc += analysis.InformationContent[0];
+        avgDbi += analysis.DensityBasinInformation[0];
+        avgPic += analysis.PartialInformationContent[0];
+        avgIS += analysis.InformationStability;
+        avgDiv += analysis.Diversity;
+        avgReg += analysis.Regularity;
+        avgEnt += analysis.TotalEntropy[0];
+        avgPkIc += analysis.PeakInformationContent.Value;
+        avgPkDbi += analysis.PeakDensityBasinInformation.Value;
+      }
+      avgAc1 /= count;
+      avgCorLen /= count;
+      avgIc /= count;
+      avgDbi /= count;
+      avgPic /= count;
+      avgIS /= count;
+      avgDiv /= count;
+      avgReg /= count;
+      avgEnt /= count;
+      avgPkIc /= count;
+      avgPkDbi /= count;
+      var isResults = new Dictionary<string, double>() {
+        { "AutoCorrelation1", avgAc1 },
+        { "CorrelationLength", avgCorLen },
+        { "InformationContent", avgIc },
+        { "DensityBasinInformation", avgDbi },
+        { "PartialInformationContent", avgPic },
+        { "InformationStability", avgIS },
+        { "Diversity", avgDiv },
+        { "Regularity", avgReg },
+        { "TotalEntropy", avgEnt },
+        { "PeakInformationContent", avgPkIc },
+        { "PeakDensityBasinInformation", avgPkDbi }
+      };
+      #endregion
+
+      foreach (var chara in characteristics.CheckedItems.Select(x => x.Value.Value)) {
+        if (Enum.TryParse<CurveAnalysisFeature>(chara, out var caf))
+          yield return new Result(Type.ToString() + "-DW." + NBHOOD_STR + "." + chara, new DoubleValue(result.GetValue(caf)));
+        else yield return new Result(Type.ToString() + "-DW." + NBHOOD_STR + "." + chara, new DoubleValue(isResults[chara]));
+      }
+      yield return new Result("EvaluatedSolutions", new IntValue((int)Math.Round(_evaluatedSolutions)));
+    }
+
+    private IEnumerable<Permutation> CalculateRelinkingPoints() {
+      IRandom random = Seed.HasValue ? new MersenneTwister((uint)Seed.Value) : new MersenneTwister();
+      var qap = (QuadraticAssignmentProblem)Problem;
+      var pathCount = Paths;
+
+      var perm = new Permutation(PermutationTypes.Absolute, qap.Weights.Rows, random);
+      var startLocal = Type == WalkType.LocalGlobal || Type == WalkType.LocalLocal;
+      var targetLocal = Type == WalkType.LocalLocal || Type == WalkType.RandomLocal;
+      var targetGlobal = Type == WalkType.LocalGlobal || Type == WalkType.RandomGlobal;
+      var inverseWalk = Type == WalkType.LocalInverse;
+
+      if (Type == WalkType.LocalInverse) pathCount--; // inverse walks equal one walk per solution
+      for (var i = 0; i <= pathCount; i++) {
+        var start = i % 2 == 0;
+        var target = i % 2 == 1;
+        if (inverseWalk || start && startLocal) {
+          perm = new Permutation(PermutationTypes.Absolute, qap.Weights.Rows, random);
+          var fit = new DoubleValue(QAPEvaluator.Apply(perm, qap.Weights, qap.Distances));
+          _evaluatedSolutions++;
+          var evalSol = new IntValue(0);
+          QAPExhaustiveSwap2LocalImprovement.ImproveFast(perm, qap.Weights, qap.Distances, fit, new IntValue(0), evalSol, qap.Maximization.Value, int.MaxValue, CancellationToken.None);
+          _evaluatedSolutions += evalSol.Value;
+        } else if (target && (targetLocal || targetGlobal)) {
+          if (targetGlobal) {
+            perm = qap.BestKnownSolutions.SampleRandom(random);
+          } else {
+            perm = new Permutation(PermutationTypes.Absolute, qap.Weights.Rows, random);
+            var fit = new DoubleValue(QAPEvaluator.Apply(perm, qap.Weights, qap.Distances));
+            _evaluatedSolutions++;
+            var evalSol = new IntValue(0);
+            QAPExhaustiveSwap2LocalImprovement.ImproveFast(perm, qap.Weights, qap.Distances, fit, new IntValue(0), evalSol, qap.Maximization.Value, int.MaxValue, CancellationToken.None);
+            _evaluatedSolutions += evalSol.Value;
+          }
+        } else { // random
+          BiasedShuffle(perm, random);
+        }
+        yield return (Permutation)perm.Clone();
+      }
+    }
+
+    private IEnumerable<List<Tuple<Permutation, double>>> Run(IEnumerable<Permutation> permutations) {
+      if (Type == WalkType.LocalInverse) return RunInverse(permutations);
+      return RunRegular(permutations);
+    }
+
+    private IEnumerable<List<Tuple<Permutation, double>>> RunInverse(IEnumerable<Permutation> permutations) {
+      var qap = (QuadraticAssignmentProblem)Problem;
+      var min = qap.LowerBound.Value;
+      var max = qap.AverageQuality.Value;
+      var bestImprovement = BestImprovement;
+
+      foreach (var start in permutations) {
+        var startFitness = QAPEvaluator.Apply(start, qap.Weights, qap.Distances);
+        _evaluatedSolutions++;
+
+        // inverse walks are applied to all solutions
+        Func<Tuple<Permutation, double>, IEnumerable<Tuple<Permutation, double>>> inverseNeighborFunc = (p) => RestrictedInverseNeighborhood(qap, p.Item1, p.Item2, start);
+        var walk = DirectedWalk<Permutation>.WalkRestricted(qap.Maximization.Value, inverseNeighborFunc, start, startFitness, !bestImprovement);
+        yield return walk.Select(x => Tuple.Create(x.Item1, (x.Item2 - min) / (max - min))).ToList();
+      } // end paths
+    }
+
+    private IEnumerable<List<Tuple<Permutation, double>>> RunRegular(IEnumerable<Permutation> permutations) {
+      var iter = permutations.GetEnumerator();
+      if (!iter.MoveNext()) yield break;
+      var bestImprovement = BestImprovement;
+
+      var qap = (QuadraticAssignmentProblem)Problem;
+      var min = qap.LowerBound.Value;
+      var max = qap.AverageQuality.Value;
+
+      var start = iter.Current;
+      
+      while (iter.MoveNext()) {
+        var startFitness = QAPEvaluator.Apply(start, qap.Weights, qap.Distances);
+        _evaluatedSolutions++;
+        var end = iter.Current;
+
+        var invSol = new int[start.Length];
+        Func<Tuple<Permutation, double>, IEnumerable<Tuple<Permutation, double>>> regularNeighborFunc = (p) => RestrictedNeighborhood(qap, p.Item1, p.Item2, end, invSol);
+        var walk = DirectedWalk<Permutation>.WalkRestricted(qap.Maximization.Value, regularNeighborFunc, start, startFitness, !bestImprovement);
+
+        var trail = new List<Tuple<Permutation, double>>();
+        foreach (var step in walk) {
+          for (var i = 0; i < invSol.Length; i++)
+            invSol[step.Item1[i]] = i;
+          trail.Add(Tuple.Create(step.Item1, (step.Item2 - min) / (max - min)));
+        }
+        yield return trail;
+
+        start = end;
+      } // end paths
+    }
+
+    private IEnumerable<Tuple<Permutation, double>> RestrictedInverseNeighborhood(QuadraticAssignmentProblem qap, Permutation current, double currentFit, Permutation start) {
+      var evalSolPerMove = 4.0 / current.Length;
+      var N = current.Length;
+      for (var index = 0; index < N; index++) {
+        if (current[index] != start[index]) continue;
+        for (var k = 0; k < N; k++) {
+          if (k == index) continue;
+          var fit = QAPSwap2MoveEvaluator.Apply(current, new Swap2Move(index, k), qap.Weights, qap.Distances);
+          _evaluatedSolutions += evalSolPerMove;
+          current.Swap(index, k);
+          yield return Tuple.Create(current, currentFit + fit);
+          current.Swap(index, k); // reverse
+        }
+      }
+    }
+
+    private IEnumerable<Tuple<Permutation, double>> RestrictedNeighborhood(QuadraticAssignmentProblem qap, Permutation current, double currentFit, Permutation target, int[] inverse) {
+      var evalSolPerMove = 4.0 / current.Length;
+      for (var index = 0; index < current.Length; index++) {
+        if (current[index] == target[index]) continue;
+        var k = inverse[target[index]];
+        var fit = QAPSwap2MoveEvaluator.Apply(current, new Swap2Move(index, k), qap.Weights, qap.Distances);
+        _evaluatedSolutions += evalSolPerMove;
+        current.Swap(index, k);
+        yield return Tuple.Create(current, currentFit + fit);
+        current.Swap(index, k); // reverse
+      }
+    }
+
+    // permutation must be strictly different in every position
+    private static void BiasedShuffle(Permutation p, IRandom random) {
+      for (var i = p.Length - 1; i > 0; i--) {
+        // Swap element "i" with a random earlier element (excluding itself)
+        var swapIndex = random.Next(i);
+        var h = p[swapIndex];
+        p[swapIndex] = p[i];
+        p[i] = h;
+      }
+    }
+  }
+}
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/RandomWalkCalculator.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/RandomWalkCalculator.cs	(revision 16136)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/RandomWalkCalculator.cs	(revision 16137)
@@ -20,4 +20,6 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -25,42 +27,17 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Threading;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
   [Item("Random Walk Calculator", "Calculates characteristics from a random walk.")]
   [StorableClass]
-  public class RandomWalkCalculator : NamedItem, ICharacteristicCalculator {
-
-    [Storable]
-    private IProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-      set {
-        if (problem == value) return;
-        problem = value;
-        var soProblem = problem as ISingleObjectiveHeuristicOptimizationProblem;
-        walker.Problem = soProblem;
-      }
-    }
-
-    [Storable]
-    private RandomWalk walker;
+  public sealed class RandomWalkCalculator : AlgorithmCharacteristicCalculator<RandomWalk> {
 
     [StorableConstructor]
     private RandomWalkCalculator(bool deserializing) : base(deserializing) { }
-    private RandomWalkCalculator(RandomWalkCalculator original, Cloner cloner)
-      : base(original, cloner) {
-      problem = cloner.Clone(original.problem);
-      walker = cloner.Clone(original.walker);
-      characteristics = cloner.Clone(original.characteristics);
-    }
+    private RandomWalkCalculator(RandomWalkCalculator original, Cloner cloner) : base(original, cloner) { }
     public RandomWalkCalculator() : this(new RandomWalk()) { }
-    public RandomWalkCalculator(RandomWalk walker) {
+    public RandomWalkCalculator(RandomWalk walker) : base(walker) {
       Name = ItemName;
       Description = ItemDescription;
-      this.walker = walker;
       characteristics = new CheckedItemList<StringValue>(
         new[] { "AutoCorrelation1", "CorrelationLength", "InformationContent",
@@ -74,43 +51,11 @@
     }
 
-    private CheckedItemList<StringValue> characteristics;
-    public ReadOnlyCheckedItemList<StringValue> Characteristics {
-      get { return characteristics.AsReadOnly(); }
+    public override bool CanCalculate() {
+      return base.CanCalculate() && Problem.Operators.Any(x => x is IManipulator);
     }
 
-    public bool CanCalculate() {
-      return Problem is ISingleObjectiveHeuristicOptimizationProblem
-        && Problem.Operators.Any(x => x is IManipulator);
-    }
-
-    public IEnumerable<IResult> Calculate() {
-      walker.Prepare(true);
-      using (var waitHandle = new AutoResetEvent(false)) {
-        EventHandler evHandle = (sender, e) => {
-          if (walker.ExecutionState == ExecutionState.Paused
-          || walker.ExecutionState == ExecutionState.Stopped) waitHandle.Set();
-        };
-        walker.ExecutionStateChanged += evHandle;
-        try {
-          walker.Start();
-          waitHandle.WaitOne();
-        } finally { walker.ExecutionStateChanged -= evHandle; }
-      }
-      foreach (var p in characteristics.CheckedItems) {
-        var resultName = "RandomWalk." + walker.MutatorParameter.Value.Name + "." + p.Value.Value;
-        IResult result;
-        if (walker.Results.TryGetValue(p.Value.Value, out result)) {
-          yield return new Result(resultName, result.Value);
-        } else yield return new Result(resultName, new DoubleValue(0));
-      }
-      walker.Prepare(true);
-    }
-
-    public void CollectParameterValues(IDictionary<string, IItem> values) {
-      walker.CollectParameterValues(values);
-    }
-
-    public IKeyedItemCollection<string, IParameter> Parameters {
-      get { return ((IParameterizedItem)walker).Parameters; }
+    public override IEnumerable<IResult> Calculate() {
+      foreach (var result in base.Calculate())
+        yield return new Result("RandomWalk." + Algorithm.MutatorParameter.Value.Name + "." + result.Name, result.Value);
     }
   }
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/UpDownWalkCalculator.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/UpDownWalkCalculator.cs	(revision 16136)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/CharacteristicCalculator/UpDownWalkCalculator.cs	(revision 16137)
@@ -20,4 +20,6 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -25,42 +27,17 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Threading;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
   [Item("Up/Down Walk Calculator", "Calculates characteristics from an up/down walk.")]
   [StorableClass]
-  public class UpDownWalkCalculator : NamedItem, ICharacteristicCalculator {
-
-    [Storable]
-    private IProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-      set {
-        if (problem == value) return;
-        problem = value;
-        var soProblem = problem as ISingleObjectiveHeuristicOptimizationProblem;
-        walker.Problem = soProblem;
-      }
-    }
-
-    [Storable]
-    private UpDownWalk walker;
+  public sealed class UpDownWalkCalculator : AlgorithmCharacteristicCalculator<UpDownWalk> {
 
     [StorableConstructor]
     private UpDownWalkCalculator(bool deserializing) : base(deserializing) { }
-    private UpDownWalkCalculator(UpDownWalkCalculator original, Cloner cloner)
-      : base(original, cloner) {
-      problem = cloner.Clone(original.problem);
-      walker = cloner.Clone(original.walker);
-      characteristics = cloner.Clone(original.characteristics);
-    }
+    private UpDownWalkCalculator(UpDownWalkCalculator original, Cloner cloner) : base(original, cloner) { }
     public UpDownWalkCalculator() : this(new UpDownWalk()) { }
-    public UpDownWalkCalculator(UpDownWalk walker) {
+    public UpDownWalkCalculator(UpDownWalk walker) : base(walker) {
       Name = ItemName;
       Description = ItemDescription;
-      this.walker = walker;
       characteristics = new CheckedItemList<StringValue>(
         new[] { "AutoCorrelation1", "CorrelationLength", "InformationContent",
@@ -75,38 +52,11 @@
     }
 
-    private CheckedItemList<StringValue> characteristics;
-    public ReadOnlyCheckedItemList<StringValue> Characteristics {
-      get { return characteristics.AsReadOnly(); }
+    public override bool CanCalculate() {
+      return base.CanCalculate() && Problem.Operators.Any(x => x is IManipulator);
     }
 
-    public bool CanCalculate() {
-      return Problem is ISingleObjectiveHeuristicOptimizationProblem
-        && Problem.Operators.Any(x => x is IManipulator);
-    }
-
-    public IEnumerable<IResult> Calculate() {
-      walker.Prepare(true);
-      using (var waitHandle = new AutoResetEvent(false)) {
-        EventHandler evHandle = (sender, e) => {
-          if (walker.ExecutionState == ExecutionState.Paused
-          || walker.ExecutionState == ExecutionState.Stopped) waitHandle.Set();
-        };
-        walker.ExecutionStateChanged += evHandle;
-        walker.Start();
-        waitHandle.WaitOne();
-        walker.ExecutionStateChanged -= evHandle;
-      }
-      foreach (var p in characteristics.CheckedItems) {
-        yield return new Result("UpDownWalk." + walker.MutatorParameter.Value.Name + "." + p.Value.Value, walker.Results[p.Value.Value].Value);
-      }
-      walker.Prepare(true);
-    }
-
-    public void CollectParameterValues(IDictionary<string, IItem> values) {
-      walker.CollectParameterValues(values);
-    }
-
-    public IKeyedItemCollection<string, IParameter> Parameters {
-      get { return ((IParameterizedItem)walker).Parameters; }
+    public override IEnumerable<IResult> Calculate() {
+      foreach (var result in base.Calculate())
+        yield return new Result("UpDownWalk." + Algorithm.MutatorParameter.Value.Name + "." + result.Name, result.Value);
     }
   }
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/HeuristicLab.Analysis.FitnessLandscape-3.3.csproj
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/HeuristicLab.Analysis.FitnessLandscape-3.3.csproj	(revision 16136)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/HeuristicLab.Analysis.FitnessLandscape-3.3.csproj	(revision 16137)
@@ -187,5 +187,5 @@
   <ItemGroup>
     <Compile Include="Algorithms\AdaptiveWalk.cs" />
-    <Compile Include="Algorithms\FLACharacterizer.cs" />
+    <Compile Include="CharacteristicCalculator\FLACharacterizer.cs" />
     <Compile Include="Algorithms\UpDownWalk.cs" />
     <Compile Include="Algorithms\RandomWalk.cs" />
@@ -201,15 +201,15 @@
     <Compile Include="Algorithms\LocalAnalysisMainLoop.cs" />
     <Compile Include="Analysis\InformationAnalyzer.cs" />
-    <Compile Include="Analysis\UniqueThresholdCalculator.cs" />
+    <Compile Include="CharacteristicCalculator\AlgorithmCharacteristicCalculator.cs" />
+    <Compile Include="Utilities\UniqueThresholdCalculator.cs" />
     <Compile Include="CharacteristicCalculator\AdaptiveWalkCalculator.cs" />
     <Compile Include="CharacteristicCalculator\UpDownWalkCalculator.cs" />
     <Compile Include="CharacteristicCalculator\RandomWalkCalculator.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\CharacteristicCalculator.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\CurveAnalysis.cs" />
+    <Compile Include="CharacteristicCalculator\CharacteristicCalculator.cs" />
+    <Compile Include="Utilities\CurveAnalysis.cs" />
     <Compile Include="Algorithms\DirectedWalk.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\DoubleMatrixCharacteristicCalculator.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\PermutationPathAnalysis.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\QAP\QAPCharacteristicCalculator.cs" />
-    <Compile Include="ProblemCharacteristicAnalysis\QAP\QAPDirectedWalk.cs" />
+    <Compile Include="Utilities\DoubleMatrixCharacteristics.cs" />
+    <Compile Include="CharacteristicCalculator\QAP\QAPCharacteristicCalculator.cs" />
+    <Compile Include="CharacteristicCalculator\QAP\QAPDirectedWalk.cs" />
     <Compile Include="ProblemInstanceAnalysis\DirectedPath.cs" />
     <Compile Include="ProblemInstanceAnalysis\ProblemInstanceAnalyzer.cs" />
Index: /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/ProblemInstanceAnalysis/QAPPRProblemInstanceAnalyzer.cs
===================================================================
--- /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/ProblemInstanceAnalysis/QAPPRProblemInstanceAnalyzer.cs	(revision 16136)
+++ /branches/2457_ExpertSystem/HeuristicLab.Analysis.FitnessLandscape/3.3/ProblemInstanceAnalysis/QAPPRProblemInstanceAnalyzer.cs	(revision 16137)
@@ -49,5 +49,6 @@
       if (trajectories.Count == 0) return null;
 
-      return new DoubleArray(PermutationPathAnalysis.GetCharacteristics(trajectories).GetValues().ToArray());
+      var result = CurveAnalysis<Permutation>.GetCharacteristics(trajectories, (left, right) => (1.0 - HammingSimilarityCalculator.CalculateSimilarity(left, right)) * left.Length);
+      return new DoubleArray(result.GetValues().ToArray());
     }
   }
